<?php

if($_GET['source'] == "pretty")
{
	show_source($SCRIPT_FILENAME);
	exit();
}
elseif($_GET['source'] == "plain")
{
	header("Content-type: text/plain");
	readfile($SCRIPT_FILENAME);
	exit();
}

if(in_array($_GET['i'],range(1,50))) {
	$iterations = $_GET['i'];
} else {
	$iterations = 10;
}

echo "<html>\n";
echo "<body bgcolor=\"#cccccc\">\n";
echo "<pre>\n";


$funcname = 'var_assign';
$funcdesc = 'assign 50 template variables and parse/print';

if(empty($_GET['func']) || empty($_GET['loop'])) {
	$exec_loop = $registered_funcs;
} else {
	$exec_loop = array($_GET['func'] => $_GET['loop']);
}

// template engine name => engine info
$registered_engines = array('smarty' => array('version' => '2.1.0','url' => 'http://smarty.php.net/'),
							'smarty-cache' => array('version' => '2.1.0','url' => 'http://smarty.php.net/'),
							'fasttemplate' => array('version' => '1.1.0','url' => 'http://www.thewebmasters.net/php/FastTemplate.phtml'),
							'phemplate' => array('version' => '1.7.1','url' => 'http://pukomuko.esu.lt/phemplate/'),
							'phplib' => array('version' => '7.2d','url' => 'http://phplib.sourceforge.net/'),
							'ultratemplate' => array('version' => '2.4.0','url' => 'http://www.ultratemplate.com/'),
							'templatepower' => array('version' => '3.0.1','url' => 'http://templatepower.codocad.com/'),
							'pattemplate' => array('version' => '2.4','url' => 'http://www.php-tools.de/'),
							'pearIT' => array('version' => '1.5','url' => 'http://pear.php.net/'),
							'modelixe' => array('version' => '1.0','url' => 'http://modelixe.phpedit.com/'),
							'btemplate' => array('version' => '0.1','url' => 'http://www.massassi.com/bTemplate/'),
							'simpletemplate' => array('version' => '1.17', 'url' => 'http://sf.net/projects/simpletpl/')
							);

echo "<b>$funcname: $funcdesc ($iterations iterations)</b>\n\n";
echo "e = manually execute script\n";
echo "s = view source code\n\n";
// loop through each registered template engine
foreach($registered_engines as $engine => $version) {
	$URL = "http://".$_SERVER['SERVER_NAME'].dirname($_SERVER['SCRIPT_NAME'])."/benchmark_$funcname/$engine/index.php";
	echo "<a href=\"$URL\">e</a> <a href=\"$URL.txt\">s</a> executing <b>$funcname</b> on <b>$engine</b> ";
	flush();
	// execute benchmark
	$results[$engine] = run_benchmark($URL,$iterations);
	echo " ".$results[$engine]."\n";
}

echo "</pre>\n";

if(!empty($results)) {
	
	echo "<table border=1>\n";
		echo "<tr align=center bgcolor=\"#eeeeee\"><td colspan=4><b>RESULTS for $funcname: $iterations iterations</b></td></tr>\n";
		echo "<tr align=center><td><b>engine</b></td><td><b>time</b></td><td><b>percent</b></td><td><b>graph (shorter=better)</b></td></tr>\n";
		asort($results);
		reset($results);
		$min_time = min($results);
		$max_time = max($results);
		foreach($results as $engine => $engine_time) {
			$pct = (int) ($engine_time * 100 / $min_time);
			$image_width = (int) ($engine_time * 200 / $max_time);
			echo "<tr><td><b><a href=\"".$registered_engines[$engine]['url']."\">$engine ".$registered_engines[$engine]['version']."</a></b></td><td align=right>".(int)($engine_time*1000)."ms</td><td align=right>$pct%</td><td><img src=\"./images/blue.gif\" border=0 height=15 width=$image_width></td></tr>\n";
			flush();
		}
	
	echo "</table>\n";
	
}

echo '<P> show source <A href="'.$_ENV['SCRIPT_NAME'].'?source=plain">Plain</A> <A href="'.$_ENV['SCRIPT_NAME'].'?source=pretty">Pretty</A></P>';

echo "</body>\n";
echo "</html>\n";

function get_microtime()
{
	$mtime = microtime();
	$mtime = explode(" ", $mtime);
	$mtime = (double)($mtime[1]) + (double)($mtime[0]);
	return ($mtime);
}

function run_benchmark($URL,$iterations) {
	$time1 = get_microtime();
	for($x=0; $x<$iterations; $x++) {
		$fp = fopen($URL,'r');
		while(!feof ($fp)) {
			fgets($fp, 4096);
		}
		fclose($fp);
		echo ".";
		flush();
	}
	return get_microtime() - $time1;
}


?>
